package com.javacodegeeks.reactivestreams

import java.nio.file.Path
import java.nio.file.Paths

import akka.actor.ActorSystem
import akka.stream.ActorMaterializer
import akka.stream.scaladsl.FileIO
import akka.stream.scaladsl.Framing
import akka.util.ByteString
import akka.stream.scaladsl.Flow
import akka.stream.scaladsl.Source
import akka.stream.scaladsl.Sink
import akka.stream.scaladsl.Keep
import scala.concurrent.Future
import scala.util.Success
import scala.concurrent.duration._
import scala.util.Random
import akka.stream.Supervision
import akka.stream.ActorAttributes.SupervisionStrategy
import akka.stream.ActorAttributes

object FlowErrors extends App {
  implicit val system = ActorSystem("reactive-streams")
  implicit val materializer = ActorMaterializer()
  implicit val executionContext = system.dispatcher
  
  val source = Source
    .unfold(0) { e => Some(e + 1, e + 1) }
    .map { e => if (e % 2 != 0) e else throw new IllegalArgumentException("Only odd numbers are allowed") }
    .withAttributes(ActorAttributes.supervisionStrategy(_ => Supervision.Resume))
    .take(10)
    .runForeach { println _ }
    .onComplete { _ => system.terminate() }
}
