package com.javacodegeeks.reactivestreams

import akka.NotUsed
import akka.actor.ActorSystem
import akka.stream.ActorMaterializer
import akka.stream.scaladsl.Source
import akka.stream.scaladsl.Sink
import akka.stream.scaladsl.Keep
import scala.concurrent.Future

object MapSource extends App {
  implicit val system = ActorSystem("reactive-streams")
  implicit val materializer = ActorMaterializer()
  implicit val executionContext = system.dispatcher
  
  val numbers = List(100, 200, 300, 400, 500)
  val source: Source[Int, NotUsed] = Source(numbers)
  
  source
    .map { _ * 2 }
    .runForeach { println _ }
    .onComplete { _ => system.terminate() }
}
